"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Grid = void 0;
const react_1 = __importDefault(require("react"));
const cell_group_1 = require("@ui-parts/grid/cell-group");
const frame_1 = require("@ui-parts/grid/frame");
const load_more_1 = require("@ui-parts/grid/load-more");
const layout_1 = require("@ui-parts/grid/layout");
const cell_component_1 = require("./cell.component");
const header_cell_component_1 = require("./header-cell.component");
const header_component_1 = require("./header.component");
const row_component_1 = require("./row.component");
const defaultGetRowKey = (item, index) => item.id || index;
const fillColumns = (columns = []) => columns.map(column => {
    if (column.children && Array.isArray(column.children)) {
        return Object.assign(Object.assign({}, column), { cell: cell_group_1.CellGroup, children: fillColumns(column.children), style: column.style || {}, header: Object.assign(Object.assign({}, (column.header || {})), { cell: cell_group_1.CellGroup }) });
    }
    return Object.assign(Object.assign({}, column), { cell: cell_component_1.Cell, style: column.style || {}, header: Object.assign(Object.assign({}, (column.header || {})), { cell: header_cell_component_1.HeaderCell }) });
});
const Grid = ({ data, columns: defaultColumns, row: Row = row_component_1.Row, loadMore, hideHeader, getRowKey = defaultGetRowKey, order, onOrder, }) => {
    const columns = fillColumns(defaultColumns);
    const layout = layout_1.useLayout(columns);
    return (react_1.default.createElement(frame_1.Frame, null,
        !hideHeader && react_1.default.createElement(header_component_1.Header, { layout: layout, columns: columns, order: order, onOrder: onOrder }),
        data.map((item, rowIndex) => (react_1.default.createElement(Row, { key: getRowKey(item, rowIndex), index: rowIndex, layout: layout, columns: columns, data: item }))),
        react_1.default.createElement(load_more_1.LoadMore, { loadMore: loadMore, cell: cell_component_1.Cell, row: Row })));
};
exports.Grid = Grid;
