"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Base = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("react");
const panel_1 = require("@admui/panel");
const text_1 = require("@admui/text");
const grid_1 = require("./grid");
exports.default = {
    title: 'Компоненты/Таблица',
};
const columns = [
    {
        size: ['2fr', '2fr', '4fr'],
        cellMinSize: ['8em', '8em', '10em'],
        children: [
            {
                title: 'Email',
                size: ['1fr', '2fr', '2fr'],
                name: 'email',
                order: {
                    by: 'email',
                },
            },
            {
                size: ['1fr', '2fr', '2fr'],
                cellMinSize: ['4em', '6em', '8em'],
                children: [
                    {
                        title: 'Имя',
                        size: ['5em', '1fr', '1fr'],
                        name: 'firstName',
                    },
                    {
                        title: 'Фамилия',
                        size: ['5em', '1fr', '1fr'],
                        name: 'lastName',
                    },
                ],
            },
        ],
    },
    {
        size: ['1fr', '1fr', '3fr'],
        cellMinSize: ['4em', '8em', '10em'],
        children: [
            {
                title: 'Статус',
                size: ['5em', '1fr', '1fr'],
                name: 'status',
                order: {
                    by: 'status',
                },
            },
            {
                title: 'Создан',
                size: ['5em', '1fr', '1fr'],
                name: 'createdAt',
                order: {
                    by: 'createdAt',
                },
            },
        ],
    },
];
const data = [
    {
        email: 'user1@example.com',
        firstName: 'Сергей',
        lastName: 'Петров',
        status: 'Активный',
        createdAt: '11 ноября 2019',
        partNumber: '100-10001',
        description: 'Description of part',
        orderQty: 10,
        receiveQty: 20,
        cost: '$5.00',
        extendedCost: '$2.00',
    },
    {
        email: 'user1@example.com',
        firstName: 'Сергей',
        lastName: 'Петров',
        status: 'Активный',
        createdAt: '11 ноября 2019',
        partNumber: '100-10001',
        description: 'Description of part',
        orderQty: 10,
        receiveQty: 20,
        cost: '$5.00',
        extendedCost: '$2.00',
    },
    {
        email: 'user1@example.com',
        firstName: 'Сергей',
        lastName: 'Петров',
        status: 'Активный',
        createdAt: '11 ноября 2019',
        partNumber: '100-10001',
        description: 'Description of part',
        orderQty: 10,
        receiveQty: 20,
        cost: '$5.00',
        extendedCost: '$2.00',
    },
    {
        email: 'user1@example.com',
        firstName: 'Сергей',
        lastName: 'Петров',
        status: 'Активный',
        createdAt: '11 ноября 2019',
        partNumber: '100-10001',
        description: 'Description of part',
        orderQty: 10,
        receiveQty: 20,
        cost: '$5.00',
        extendedCost: '$2.00',
    },
];
exports.Base = () => {
    const [order, setOrder] = react_2.useState({
        by: 'email',
        direction: 'desc',
    });
    return (react_1.default.createElement("div", { style: { width: '100%', height: 400 } },
        react_1.default.createElement(panel_1.Panel, null,
            react_1.default.createElement(grid_1.Grid, { columns: columns, data: data, order: order, loadMore: react_1.default.createElement(text_1.Text, null, "\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044C \u0435\u0449\u0435"), onOrder: setOrder }))));
};
exports.Base.story = {
    name: 'Базовывй',
};
