"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderCellOrder = void 0;
const react_1 = __importDefault(require("react"));
const styled_1 = __importDefault(require("@emotion/styled"));
const react_2 = require("react");
const Arrow = styled_1.default.span(({ theme }) => ({
    color: theme.base === 'dark' ? 'white' : '#334681',
    fontWeight: 'bold',
    fontSize: 13,
}));
const ArrowsContainer = styled_1.default.span(() => ({
    paddingLeft: 6,
    paddingRight: 6,
}));
const Arrows = react_2.memo(({ ordered, order }) => {
    const arrows = [];
    if (ordered) {
        arrows.push(react_1.default.createElement(Arrow, { key: 'single' }, order.direction === 'asc' ? '↑' : '↓'));
    }
    else {
        arrows.push(react_1.default.createElement(Arrow, { key: 'up' }, "\u2191"));
        arrows.push(react_1.default.createElement(Arrow, { key: 'down' }, "\u2193"));
    }
    return react_1.default.createElement(ArrowsContainer, null, arrows);
});
const HeaderCellOrder = ({ hovered, order, column }) => {
    var _a;
    if (!((_a = column === null || column === void 0 ? void 0 : column.order) === null || _a === void 0 ? void 0 : _a.by) || !order) {
        return null;
    }
    const ordered = react_2.useMemo(() => { var _a; return (order === null || order === void 0 ? void 0 : order.by) === ((_a = column === null || column === void 0 ? void 0 : column.order) === null || _a === void 0 ? void 0 : _a.by); }, [order]);
    if (hovered || ordered) {
        return react_1.default.createElement(Arrows, { ordered: ordered, order: order });
    }
    return null;
};
exports.HeaderCellOrder = HeaderCellOrder;
