"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderCell = void 0;
const styled_1 = __importDefault(require("@emotion/styled"));
const hover_1 = __importDefault(require("@react-hook/hover"));
const react_1 = __importStar(require("react"));
const header_cell_1 = require("@ui-parts/grid/header-cell");
const react_2 = require("react");
const header_cell_order_1 = require("./header-cell-order");
const BaseHeaderCell = styled_1.default(header_cell_1.HeaderCellElement)(({ theme }) => ({
    fontSize: 14,
    fontWeight: 500,
    color: '#A1AAC7',
    cursor: 'pointer',
}));
BaseHeaderCell.defaultProps = {
    padding: 16,
};
const BaseHeaderCellWithRef = react_1.forwardRef((props, ref) => (react_1.default.createElement(BaseHeaderCell, Object.assign({}, props, { ref: ref }))));
const HeaderCell = (_a) => {
    var { onOrder } = _a, props = __rest(_a, ["onOrder"]);
    const ref = react_2.useRef(null);
    const isHovered = hover_1.default(ref, { enterDelay: 200, leaveDelay: 200 });
    const onHandleOrder = react_1.useCallback(() => {
        var _a, _b, _c, _d;
        if (onOrder) {
            onOrder({
                by: ((_b = (_a = props.column) === null || _a === void 0 ? void 0 : _a.order) === null || _b === void 0 ? void 0 : _b.by) || ((_c = props.column) === null || _c === void 0 ? void 0 : _c.name),
                direction: ((_d = props.order) === null || _d === void 0 ? void 0 : _d.direction) === 'desc' ? 'asc' : 'desc',
            });
        }
    }, [props.order, onOrder]);
    return (react_1.default.createElement(BaseHeaderCellWithRef, Object.assign({}, props, { ref: ref, onClick: onHandleOrder, additions: react_1.default.createElement(header_cell_order_1.HeaderCellOrder, { hovered: isHovered, order: props.order, column: props.column }) })));
};
exports.HeaderCell = HeaderCell;
